{{ define "main" }}
  {{ $vulnerabilities := .Site.Data.vulnerabilities }}
  {{ with $vulnerabilities }}
    <div class="row">
      <div class="col-lg">
        <canvas id="myChart"></canvas>
      </div>
      <div class="col-lg table-responsive">
        <table class="table table-striped table-hover">
          <thead>
            <tr class="text-end">
              <th scope="col" class="text-start">Severity</th>
              <th scope="col">Over 30 days</th>
              <th scope="col">Over 60 days</th>
              <th scope="col">Over 90 days</th>
              <th scope="col">Over 120 days</th>
              <th scope="col">Over 1 year</th>
            </tr>
          </thead>
          <tbody id="listTable">
            {{ $data := newScratch }}
            {{ range $vulnerabilities.aging }}
              {{ $data.Set "over_30_days" (add ($data.Get "over_30_days" | default 0) .over_30_days) }}
              {{ $data.Set "over_60_days" (add ($data.Get "over_60_days" | default 0) .over_60_days) }}
              {{ $data.Set "over_90_days" (add ($data.Get "over_90_days" | default 0) .over_90_days) }}
              {{ $data.Set "over_120_days" (add ($data.Get "over_120_days" | default 0) .over_120_days) }}
              {{ $data.Set "over_1_year" (add ($data.Get "over_1_year" | default 0) .over_1_year) }}
              <tr class="text-end">
                <td scope="row" class="text-start">{{ partial "severity" .severity }}</td>
                <td scope="row">{{ .over_30_days | lang.FormatNumber 0 }}</td>
                <td scope="row">{{ .over_60_days | lang.FormatNumber 0 }}</td>
                <td scope="row">{{ .over_90_days | lang.FormatNumber 0 }}</td>
                <td scope="row">{{ .over_120_days | lang.FormatNumber 0 }}</td>
                <td scope="row">{{ .over_1_year | lang.FormatNumber 0 }}</td>
              </tr>
            {{ end }}
          </tbody>
          <tfoot>
            <tr class="text-end">
              <td colspan="2">
                <strong>{{ $data.Get "over_30_days" | lang.FormatNumber 0 }}</strong>
              </td>
              <td><strong>{{ $data.Get "over_60_days" | lang.FormatNumber 0 }}</strong></td>
              <td><strong>{{ $data.Get "over_90_days" | lang.FormatNumber 0 }}</strong></td>
              <td><strong>{{ $data.Get "over_120_days" | lang.FormatNumber 0 }}</strong></td>
              <td><strong>{{ $data.Get "over_1_year" | lang.FormatNumber 0 }}</strong></td>
            </tr>

            <tr></tr>
          </tfoot>
        </table>
      </div>
    </div>

<script>
  const labels = [
      'Over 30 days',
      'Over 60 days',
      'Over 90 days',
      'Over 120 days',
      'Over 1 year',
    ];
  const data = {
      labels: labels,
      datasets: [
          {{ range $vulnerabilities.aging }}
          {
          label: '{{ .severity }}',
          backgroundColor: [
              {{ if or (eq .severity "critical") (eq .severity "high") }}
              'rgba(255, 99, 132, 0.3)',
              {{ else if (eq .severity "medium") }}
              'rgba(254, 181, 13, 0.3)',
              {{ else }}
              'rgba(89, 98, 105, 0.3)',
              {{ end }}
              ],
          borderColor: [
              {{ if or (eq .severity "critical") (eq .severity "high") }}
              'rgb(255, 99, 132)',
              {{ else if (eq .severity "medium") }}
              'rgb(254, 181, 13)',
              {{ else }}
              'rgb(89, 98, 105)',
              {{ end }}
          ],
          borderWidth: 1,
          data: [{{.over_30_days}}, {{.over_60_days}}, {{.over_90_days}}, {{.over_120_days}}, {{.over_1_year}}],
          },
          {{ end }}
        ]
    };
  const config = {
      type: 'bar',
      data: data,
      options: {
        animations: {
          radius: {
            duration: 500,
            easing: 'linear',
            loop: (context) => context.active
          }
        },
      }
    };

  var myChart = new Chart(
      document.getElementById('myChart'),
      config
    );
</script>

    <h2>Top 10 oldest vulnerabilities average</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr class="text-end">
            <th scope="col" class="text-start">#</th>
            <th scope="col" class="text-start">Project</th>
            <th scope="col">Average age (Critical/High/Unknown)</th>
            <th scope="col">N (Critical/High/Unknown)</th>
            <th scope="col">Average age</th>
            <th scope="col">N</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ $counter := 0 }}
          {{ range .oldest_average }}
            {{ $counter = add $counter 1 }}
            <tr class="text-end">
              <th scope="row" class="text-start">{{ $counter }}</th>
              <td class="text-start">
                <a href="{{ printf "projects/%s" .path_with_namespace | urlize | relURL }}"
                  >{{ .path_with_namespace }}</a
                >
              </td>
              <td>
                {{ if gt .avg_age_of_vulnerabilities_crit 180 }}
                  <i
                    class="fas fa-exclamation-triangle fa-fw"
                    data-bs-toggle="tooltip"
                    title="Over SLO"></i>
                {{ end }}{{ .avg_age_of_vulnerabilities_crit | lang.FormatNumber 0 }}
                days
              </td>
              <td>{{ .number_of_vulnerabilities_crit | lang.FormatNumber 0 }}</td>
              <td>
                {{ if gt .avg_age_of_vulnerabilities 180 }}
                  <i
                    class="fas fa-exclamation-triangle fa-fw"
                    data-bs-toggle="tooltip"
                    title="Over SLO"></i>
                {{ end }}{{ .avg_age_of_vulnerabilities | lang.FormatNumber 0 }}
                days
              </td>
              <td>{{ .number_of_vulnerabilities | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>
  {{ end }}
{{ end }}
